/** ised - generating integer and floating point sequences
    Copyright (C) 2009-2012  Simon Copar

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef H_METHODS
#define H_METHODS

#include "base.h"
#include "unroll.h"

//returns real zeros of the polynomial
int bairstow(array& poly, array& out);


void trimzeroes(array& a);
//returns an array that has the remainder at the front and quotient at the back
//return value is the number of components of the remainder
int polydivmod(array& a, array& b, array& divmod);

//gcd
void gcd(array& a, array& out);
//lcm
void lcm(array& a, array& out);
//primes
void pfactor(itype p, array& out);
//euler phi
itype onephi(itype n);

#endif
