/** ised - generating integer and floating point sequences
    Copyright (C) 2009-2012  Simon Copar

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/

#ifndef H_TOKENER
#define H_TOKENER

#include "base.h"


using namespace std;

#define TOK_NONE        0
#define TOK_PAR_L       1
#define TOK_PAR_R       2
#define TOK_OP          3
#define TOK_VALUE       4


struct token {
  uint type;
  uint i;
  value f;
  opid o;

  token(const value& ff){
    type=TOK_VALUE;
    f=ff;
  }
  token(const opid& op){
    type=TOK_OP;
    o=op;
  }
  token(const uchar pt, const uint t){
    type=pt;
    i=t;
  }
};


#if DEBUG>2
void printtoken(token& tok);
#endif

typedef vector<token> tokenvec;

void tokenize(char* izraz, tokenvec& tokens);

#endif
